﻿using Android.App;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Calendar;
using Java.Util;
using System.Collections.Generic;
using Android.Content;
using System;

namespace Calendar132793
{
    [Activity(Label = "Calendar132793", MainLauncher = true, Icon = "@mipmap/icon")]
    public class MainActivity : Activity
    {
        CalendarInlineEvent events, events2, events3;
        Calendar startEventDate,endEventDate;
        CalendarEventCollection eventsCollection;
        SfCalendar sfCalendar;
        ArrayList al = new ArrayList();
        ObservableArrayList oal = new ObservableArrayList();
        List<TextView> st;
        TextView tview;
        LinearLayout llayout;
        AlertDialog.Builder alert;

        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);

             alert = new AlertDialog.Builder(this);
           
		    sfCalendar = new SfCalendar(this);
            sfCalendar.ShowEventsInline = true;

            //Adding custom events
		    eventsCollection = new CalendarEventCollection();
		    events = new CalendarInlineEvent();

			//starting date of event
		    startEventDate = Calendar.Instance;
			startEventDate.Set(2017, 8, 2, 10, 0, 0);
			events.StartTime = startEventDate;

			//ending date of event
		    endEventDate = Calendar.Instance;
			endEventDate.Set(2017, 8, 8, 12, 0, 0);
			events.EndTime = endEventDate;

			//subject which will be going to add as content in Inline event appointments
			events.Subject = "Business Meeting in America";

			//Indicator color in appointments
			events.Color = Android.Graphics.Color.Red;

			//Adding another custom events
			events2 = new CalendarInlineEvent();

			//starting date of event
			startEventDate = Calendar.Instance;
			startEventDate.Set(2017, 8, 6, 10, 0, 0);
			events2.StartTime = startEventDate;

			//ending date of event
			endEventDate = Calendar.Instance;
			endEventDate.Set(2017, 8, 12, 12, 0, 0);
			events2.EndTime = endEventDate;

			//subject which will be going to add as content in Inline event appointments
			events2.Subject = "Business Meeting in India";

			//Indicator color in appointments
            events2.Color = Android.Graphics.Color.Blue;

			//Adding another custom events
			events3 = new CalendarInlineEvent();

			//starting date of event
			startEventDate = Calendar.Instance;
			startEventDate.Set(2017, 8, 17, 10, 0, 0);
			events3.StartTime = startEventDate;

			//ending date of event
			endEventDate = Calendar.Instance;
			endEventDate.Set(2017, 8, 22, 12, 0, 0);
			events3.EndTime = endEventDate;

			//subject which will be going to add as content in Inline event appointments
			events3.Subject = "Business Meeting in England";

			//Indicator color in appointments
            events3.Color = Android.Graphics.Color.Green;

			eventsCollection.Add(events);
            eventsCollection.Add(events2);
            eventsCollection.Add(events3);

            sfCalendar.DataSource = eventsCollection;

            sfCalendar.DrawInlineView+=HandleEventHandler;

			SetContentView(sfCalendar);

        }

        //Event Click
        void Ctview_ItemClicked(object sender, Calendar132793.ItemClicledEventArgs e)
        {
            alert.SetTitle("Syncfusion Support");
            alert.SetMessage("Event "+ "\n"+"Subject: "+e.Appointment.Subject+"\n"+ "Start date: "+e.Appointment.StartTime.Time+ "\n"+ "End date: " + e.Appointment.EndTime.Time);
            alert.Show();
        }

        //Adding custom View
        void HandleEventHandler(object sender, SfCalendar.DrawInlineEventArgs e)
        {
			llayout = new LinearLayout(this);
            CalendarEventCollection even = e.P1.Appointments;
            ObservableArrayList coll = even;
			st = new List<TextView>();
			
            for (int i = 0; i < even.Size();i++ )
            {
                CalendarInlineEvent app = coll.Get(i) as CalendarInlineEvent;
                CustomTextView ctview = new CustomTextView(this);
                ctview.Text = app.Subject;
                ctview.TextSize = 20;
                ctview.Tag = i;
                ctview.Appointment = even.Get(i) as CalendarInlineEvent;
                ctview.ItemClicked += Ctview_ItemClicked;
                st.Add(ctview);
            }
            for (int j = 0; j < st.Count; j++)
            {
                llayout.AddView(st[j]);
            }
            llayout.Orientation = Orientation.Vertical;

            e.P1.View = llayout;  
        }
    }

    public class CustomTextView: TextView
    {
        public CustomTextView(Context con):base(con)
        {
            this.Click += Handle_Click;
        }

        void Handle_Click(object sender, EventArgs e)
        {
            ItemClicledEventArgs args = new ItemClicledEventArgs();
            args.ItemIndex =Convert.ToInt32( this.Tag);
            args.Appointment = this.Appointment;
            OnItemClicked(args);
        }

        public event EventHandler<ItemClicledEventArgs> ItemClicked;

        internal virtual void OnItemClicked(ItemClicledEventArgs args)
        {
            if (ItemClicked != null)
                ItemClicked(this, args);
        }

        private CalendarInlineEvent appointments;

        public CalendarInlineEvent Appointment { get => appointments; set => appointments = value; }
    }

    public class ItemClicledEventArgs:EventArgs
    {
        private int itemIndex;
        private CalendarInlineEvent appointment;

        public int ItemIndex { get => itemIndex; set => itemIndex = value; }
        public CalendarInlineEvent Appointment { get => appointment; set => appointment = value; }
    }
}

